<template>
	<!-- <div class="wrap bg-wrap"> -->
	<div>
		<div class="dimmed" @click="ModalClose();"></div>
		<div class="popup-wrap">
			<!-- 테스트 ID 생성 -->
			<div class="popup modal29 popup_form">
				<div class="pop-head">
					<h3 class="pop-tit">테스트 ID 생성</h3>
				</div>
				<form autocomplete="off">
					<table>
						<tbody>
							<tr>
								<th>ID</th>
								<td><input type="text" placeholder="아이디 입력" v-model.trim="userId" ref="_userId" /></td>
							</tr>
							<tr>
								<th>비밀번호</th>
								<td><input type="password" @keypress="onlyPassword" @input="onlyPassword" required minlength="8" maxlength="16" ref="_pwd1" v-model.trim="userPwd1"></td>
							</tr>
							<tr>
								<th>비밀번호 확인</th>
								<td><input type="password" @keypress="onlyPassword" @input="onlyPassword" required minlength="8" maxlength="16" ref="_pwd2" v-model.trim="userPwd2"></td>
							</tr>
							<tr>
								<th>이름</th>
								<td><input type="text" @keypress="onlyName" @input="onlyName" v-model.trim="userNm" ref="_userNm" required maxlength="40"></td>
							</tr>
							<tr>
								<th>휴대폰번호</th>
								<td><input type="number" placeholder="- 자 제외 숫자만 입력" v-model.trim="mdn" v-on:keyup="onlyNum" @input="onlyNum" minlength="10" maxlength="11" ref="_phone"></td>
							</tr>
							<tr>
								<th>이메일</th>
								<td><input type="email" v-model.trim="email" @keypress="onlyEmail" @input="onlyEmail" maxlength="20" ref="_email"></td>
							</tr>
							<tr>
								<th class="center">상태</th>
								<td>
									<input type="radio" name="state" value="01" id="popup_radio1" v-model="userStat">
									<label for="popup_radio1">사용</label>
									<input type="radio" name="state" value="02" id="popup_radio2" v-model="userStat">
									<label for="popup_radio2">정지</label>
								</td>
							</tr>
						</tbody>
					</table>
				</form>
				<div class="pop-btn2">
					<button class="btn-default" @click="ModalClose();">취소</button>
					<button class="btn-pcolor" @click="doInsert">저장</button>
				</div>
        <common-modal ref="commmonModal"></common-modal>
			</div>
		</div>
	</div>
</template>

<script>
import custMgtApi from "../service/custMgtApi.js";
import { utils_mixin, chkPattern2 } from '../service/mixins';
import lodash from "lodash";
import commonModal from "@/components/modal/commonModal";

export default {
	name: "subsRegPop",
	mixins: [utils_mixin, chkPattern2],
	watch:{
		stat(){
		}
	},
	data(){
        return{
			row: {},
			userId:'',
			name:'',
			mdn:'',
			email:'',
			userStat: '',
			userNm:"",
            userPwd1:"",
            userPwd2:"",
			code:"",
        }
    },
	model: {
		prop: 'sendData',
		event: 'event-data'
	},
	props: ['sendData'],
  components: {
    commonModal,
  },
	created(){            
		this.formReset();
    }, 
	methods :{
		doPwdValidate(){
			if(this.isNull(this.userPwd1)){
				this.row.title = '청약고객관리';
        this.row.msg1 = '비밀번호를 입력해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._pwd1.focus();
				return false;
			}
			if(this.isNull(this.userPwd2)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '비밀번호 확인을 입력해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._pwd2.focus();
				return false;
			}
			if(!lodash.isEqual(this.userPwd1, this.userPwd2)){
				this.row.title = '청약고객관리';
        this.row.msg1 = '비밀번호가 일치하지 않습니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._pwd2.focus();
				return false;
			}
			const pwdLen = this.bytes(this.userPwd1);
			if(!(pwdLen >= 8 && pwdLen <= 16)){
				this.row.title = '청약고객관리';
        this.row.msg1 = '비밀번호는 8~16자의 영문, 숫자, 특수문자(!,@, $, %, ^, &, *) 조합이 필요합니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._pwd1.focus();
				return false;
			}
			const pEng = /[A-Za-z]/g;	// 영문자 
			const pNum = /[0-9]/g;	// 숫자 
			const pSpc = /[!@$%^&*]/g; // 특수문자
			if(!(pEng.test(this.userPwd1) && pNum.test(this.userPwd1) && pSpc.test(this.userPwd1))) {
        this.row.title = '청약고객관리';
        this.row.msg1 = '비밀번호는 8~16자의 영문, 숫자, 특수문자(!,@, $, %, ^, &, *) 조합이 필요합니다.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._pwd1.focus();
				return;
			}
			this.row.userPw=this.userPwd1;
			return true;
		},
		doValidate(){
			if(this.isNull(this.userId)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '아이디를 입력해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._userId.focus();
				return false;
			}
			if(!this.doPwdValidate()){
				return false;
			}
			if(this.isNull(this.userNm)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '이름을 입력해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._userNm.focus();
				return false;
			}
			if(this.isNull(this.mdn)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '휴대폰번호를 입력해주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._phone.focus();
				return false;
			}
			const hp = this.mdn;
			if(!this.isNull(hp) && !this.isMobile(hp)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '휴대폰 번호 형식이 잘못되었습니다. 확인해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._phone.focus();
				return false;
			}
			if(this.isNull(this.email)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '이메일을 입력해주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._email.focus();
				return false;
			}
			const email = this.email;
			if(!this.isNull(email) && !lodash.isEqual(email,'@') && !this.emailCheck(email)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '이메일 형식이 잘못되었습니다. 확인해 주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				this.$refs._email.focus();
				return false;
			}
			if(this.isNull(this.userStat)){
        this.row.title = '청약고객관리';
        this.row.msg1 = '상태를 선택 해주세요.';
        this.$refs.commmonModal.alertModalOpen(this.row);
				// this.$refs._auth.focus();
				return false;
			}
			this.row.userId=this.userId;
			this.row.name=this.userNm;
			this.row.mdn=hp;
			this.row.email=email;
			this.row.userStat=this.userStat;
			return true;
		},
		// 모달 띄우기
		ModalOpen(){
			var dimmed = document.getElementsByClassName('dimmed');
			dimmed[0].style.display = 'block';
			var wrap = document.getElementsByClassName('popup-wrap');
			wrap[0].style.display = 'block';
			var obj = document.getElementsByClassName('modal29');
			obj[0].style.display = 'block';
		},
		// 모달 끄기
		ModalClose(){
			//this.formReset();
			var dimmed = document.getElementsByClassName('dimmed');
			dimmed[0].style.display = 'none';
			var wrap = document.getElementsByClassName('popup-wrap');
			wrap[0].style.display = 'none';
			var popup = document.getElementsByClassName('modal29');
			popup[0].style.display = 'none';
			
		},
		// 저장 후 부모창 호출.
		toComplete(){
			this.getParent('custList').$refs.table.reloadData();
			this.ModalClose();
        },
		async doInsert(){
      if(this.doValidate() && window.confirm('등록 하시겠습니까?')){
        try {
					const response = await custMgtApi.insertTestId(this.row);
					const result = response.data;
					if (result != null && result.retCode == "0000") {
            this.row.title = '청약고객관리';
            this.row.msg1 = '저장 하였습니다.';
            this.$refs.commmonModal.alertModalOpen(this.row);
						this.toComplete();
					}
        } catch(err) {
          this.row.title = '청약고객관리';
          this.row.msg1 = '실패 하였습니다.';
          this.$refs.commmonModal.alertModalOpen(this.row);
        }
      }
    },
		formReset(){
			//this.$refs.adminRegForm.reset();
		},
	}
}
</script>

<style>
	.popup-btn-wrap {width: 500px; margin: auto; padding: 100px 0;}
	.popup-btn-wrap button {width: 100%; margin-bottom: 10px; height: 50px; border-radius: 5px; box-shadow: none; border: 1px solid #000; }
	.popup-btn-wrap button:hover {background: #000; color: #fff;}
</style>